# Offer Transaction Service

## Steps to install and run the application

Download and Install Postgress In Docker ::

```bash
docker pull postgres

docker run -d -e POSTGRES_USER=user -e POSTGRES_PASSWORD=password123 --name postgres -p 5432:5432  --restart=always postgres
```

Download and install pgadmin4 from below link

[PGAdmin4 ](https://www.postgresql.org/ftp/pgadmin/pgadmin4/v4.19/windows/)

after installation start the pg admin by use below url

```bash
http://127.0.0.1:58283/browser/#
```

Once you start it will ask to create a master password

Go to Add New Server --> Give any database name --> go to connection tab and provide below details

```bash
Host = 127.0.0.1
Port = 5432
username = user
password = password123
```
Then click on save

In Header click on Tool -> Query Tool --> and paste the below query

```bash
-- Table: public.offerlookup

-- DROP TABLE public.offerlookup;

CREATE TABLE public.offerlookup
(
    offer_lookup_id text COLLATE pg_catalog."default" NOT NULL,
    store_id text COLLATE pg_catalog."default" NOT NULL,
    terminal text COLLATE pg_catalog."default" NOT NULL,
    offer_type text COLLATE pg_catalog."default" NOT NULL,
    offer_id text COLLATE pg_catalog."default" NOT NULL,
    pre_condition text COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT "OfferLookup_pkey" PRIMARY KEY (offer_lookup_id)
)

TABLESPACE pg_default;

ALTER TABLE public.offerlookup
    OWNER to "postgress";

```

```bash
Once you create use the below query to insert a data

INSERT INTO public.offerlookup(
	 store_id, terminal, offer_type, offer_id, pre_condition,offer_lookup_id)
	VALUES ('0001','001','Customer','o1','AND','54321');
INSERT INTO public.offerlookup(
	store_id, terminal, offer_type, offer_id, pre_condition,offer_lookup_id)
	VALUES ('0001','001','Customer','o2','AND','54321');
INSERT INTO public.offerlookup(
	store_id, terminal, offer_type, offer_id, pre_condition,offer_lookup_id)
	VALUES ('0001','001','Customer','o3','AND','54321');
INSERT INTO public.offerlookup(
	store_id, terminal, offer_type, offer_id, pre_condition,offer_lookup_id)
	VALUES ('0001','001','Customer','o4','AND','54321');

```

```bash
Create a table for end of sale

CREATE EXTENSION IF NOT EXISTS "uuid-ossp";

CREATE TABLE endofsale(
  uuid uuid NOT NULL DEFAULT uuid_generate_v1(),
  offertransactionresponse jsonb NOT NULL,
  offers jsonb NOT NULL,
  isprocessed boolean
);

```

```bash
dummy data
==========


INSERT INTO endofsale VALUES ( uuid_generate_v4()  ,
'{"name": "Paint house", "tags": ["Improvements", "Office"], "finished": true}',
'{"name": "Paint house", "tags": ["Improvements", "Office"], "finished": true}' );
```


## Create table offer metadata


```bash

-- Table: public.offer_meta_data

-- DROP TABLE public.offer_meta_data;

CREATE TABLE public.offer_meta_data
(
    offerid text COLLATE pg_catalog."default" NOT NULL,
    eligibility text COLLATE pg_catalog."default" NOT NULL,
    discount_type text COLLATE pg_catalog."default" NOT NULL,
    status text COLLATE pg_catalog."default" NOT NULL,
    start_time timestamp with time zone NOT NULL,
    end_time timestamp with time zone NOT NULL,
    offer_desc text COLLATE pg_catalog."default" NOT NULL,
    offer_type text COLLATE pg_catalog."default" NOT NULL,
    rcpt_txt text COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT offer_meta_data_pkey PRIMARY KEY (offerid)
)

TABLESPACE pg_default;

ALTER TABLE public.offer_meta_data
    OWNER to "user";



```





```bash
dummy data
==========

INSERT INTO public.offer_meta_data(
	 offerid, eligibility, discount_type, offer_meta_status, start_time,end_time,
	offer_desc,offer_type,rcpt_txt)
	VALUES ('o1','elgibility','dicounted','Active','2020-04-14 19:10:25','2020-04-15 19:10:25',
			'30 percent','5','RCPT TXT');

INSERT INTO public.offer_meta_data(
	 offerid, eligibility, discount_type, offer_meta_status, start_time,end_time,
	offer_desc,offer_type,rcpt_txt)
	VALUES ('o2','elgibility','dicounted','InActive','2020-04-14 19:10:25','2020-04-15 19:10:25',
			'20 percent','5','RCPT TXT');

INSERT INTO public.offer_meta_data(
	 offerid, eligibility, discount_type, offer_meta_status, start_time,end_time,
	offer_desc,offer_type,rcpt_txt)
	VALUES ('o3','elgibility','dicounted','Active','2020-04-15 19:10:25','2020-04-16 19:10:25',
			'10 percent','5','RCPT TXT');
INSERT INTO public.offer_meta_data(
	 offerid, eligibility, discount_type, offer_meta_status, start_time,end_time,
	offer_desc,offer_type,rcpt_txt)
	VALUES ('o4','elgibility','dicounted','Active','2020-04-1 19:10:25','2020-04-15 19:10:25',
			'05 percent','5','RCPT TXT');


```

