package com.nisum.offertransactionservice.model;


import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldDefaults;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.time.LocalDateTime;

@Data
@NoArgsConstructor
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE, makeFinal = false)
@Entity
@Table(name = "offer_metadata")
public class OfferMeta {

    @Id
    @Column(name="offer_id")
    Long offerId;

    @Column(name="start_time")
    LocalDateTime startTime;

    @Column(name="end_time")
    LocalDateTime expiryTime;

    @Column(name="offer_meta_status")
    String offerStatus;

    @Column(name="eligibility")
    String eligibility;

    @Column(name="discount_type")
    String discount;

    @Column(name="offer_type")
    String offerType;

    @Column(name="offer_desc")
    String offerDesc;

    @Column(name="rcpt_txt")
    String rcptTxt;
}
